﻿package com.dipigraphics.fingersMotion
{
	
	//Context Menu + Event + stage
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.DisplayObject;
	import flash.display.Graphics;
	import flash.display.InteractiveObject;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.ActivityEvent;
	import flash.events.ContextMenuEvent;
	import flash.events.Event;
	import flash.events.EventDispatcher;
	import flash.events.IEventDispatcher;
	import flash.events.MouseEvent;
	import flash.events.StatusEvent;
	import flash.events.TimerEvent;
	import flash.filters.BlurFilter;
	import flash.filters.ColorMatrixFilter;
	import flash.geom.Matrix;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.media.Camera;
	import flash.media.Video;
	import flash.system.Security;
	import flash.system.SecurityPanel;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.ui.ContextMenu;
	import flash.ui.ContextMenuBuiltInItems;
	import flash.ui.ContextMenuItem;
	import flash.utils.Timer;
	


	/**
	 * The FingersMotion Class allow you to interact with your fingers using 3 colored markers.
	 * 
	 * <p>Created by Denis Pissoort</p>
	 * <p>Produced by <a href="http://www.infographie-sup.be">Haute Ecole Albert Jacquard</a></p>
	 * <p>Email : denis&#64;dipi-graphics.com</p>
	 * <p>HomePage of the project : <a href="http://www.dipi-graphics.com/TFE/project/">Fingers Motion Project HomePage</a></p>
	 * <p>This software is licensed under the <a href="http://creativecommons.org/licenses/GPL/2.0/">CC-GNU GPL</a> version 2.0 or later.</p>
	 * 
	 */
	
	public class fingersMotion extends Sprite 
	{
		
		private var webcam:Camera;
		private var vid:Video;
		private var rect:Rectangle = new Rectangle(0,0,320,240);
		private var pt:Point = new Point(0, 0);
		private var rectPoint:Rectangle;
		private var rectPointF:Rectangle;
		private var rectPointG:Rectangle;
		private var rectPointH:Rectangle;
		//Image Capture
		/**
		 * not needed
		 * @private
		 */
		public static var imageB:Bitmap;
		/**
		 * not needed
		 * @private
		 */
		public static var image:BitmapData;
		private var flip:Matrix = new Matrix();
		
		//Rectangle Capteurs 
		private var rectangle1:Shape = new Shape();//zone rectangle de detection Couleur
		private var rectangle2:Shape = new Shape();//zone rectangle de detection Couleur
		private var rectangle3:Shape = new Shape();//zone rectangle de detection Couleur
		
		//Timer
		private var t:Timer = new Timer(40);
		
		//filtre
		//blur
		/**
		 * not needed
		 * @private
		 */
		public static var flou:Number = 5;
		/**
		 * not needed
		 * @private
		 */
		public static var filter:BlurFilter = new BlurFilter(flou,flou,2);
		
		//saturation
		/**
		 * not needed
		 * @private
		 */
		public static var saturate:ColorMatrixFilter;
		/**
		 * not needed
		 * @private
		 */
		public static var s:Number = 1;
		private var rwgt:Number = .3086;
		private var gwgt:Number = .6094;
		private var bwgt:Number = .0820;
		private var a:Number;
		private var b:Number;
		private var c:Number;
		private var d:Number;
		private var e:Number;
		private var f:Number;
		private var g:Number;
		private var h:Number;
		private var i:Number;
		private var satMat:Array = new Array(a,b,c,0,0,d,e,f,0,0,g,h,i,0,0, 0, 0, 0, 1, 0);
		//capteur
		
		/**
		 * not needed
		 * @private
		 */
		public static var initCapteur1:Boolean = true;
		/**
		 * not needed
		 * @private
		 */
		public static var colorCapteur1:Vector.<uint> = new Vector.<uint>();
		/**
		 * not needed
		 * @private
		 */
		public static var hueTol1:int=5;
		/**
		 * not needed
		 * @private
		 */
		public static var lumTol1:int=1;
		
		/**
		 * not needed
		 * @private
		 */
		public static var initCapteur2:Boolean = true;
		/**
		 * not needed
		 * @private
		 */
		public static var colorCapteur2:Vector.<uint> = new Vector.<uint>();
		/**
		 * not needed
		 * @private
		 */
		public static var hueTol2:int=5;
		/**
		 * not needed
		 * @private
		 */
		public static var lumTol2:int=1;
		
		/**
		 * not needed
		 * @private
		 */
		public static var initCapteur3:Boolean = true;
		/**
		 * not needed
		 * @private
		 */
		public static var colorCapteur3:Vector.<uint> = new Vector.<uint>();
		/**
		 * not needed
		 * @private
		 */
		public static var hueTol3:int=5;
		/**
		 * not needed
		 * @private
		 */
		public static var lumTol3:int=1;
		
		private var setupXpos:Number;
		private var setupYpos:Number;
		private var markersVisibility:Boolean;
		
		/**
		 * Define the Status Event for the switch condition that dispatch event
		 * <ul>
		 * <li> 0 : normal mode</li>
		 * <li> 1 : hover mode</li>
		 * <li> 2 : drag and drop mode</li>
		 * <li> 3 : click mode</li>
		 * </ul>
		 * <p>Note : you dont need it normally except if you try to change the navigation system created.</p>
		 */
		public var fingersMotionStatut:int=0;
		
		
		private var capteur1Orig:Point = new Point(0,0);
		private var capteur2Orig:Point = new Point(0,0);
		private var capteur3Orig:Point = new Point(0,0);
		private var sphere1:Sprite = new Sprite();
		private var sphere2:Sprite = new Sprite();
		private var sphere3:Sprite = new Sprite();
		
		private var ratioX:Number;
		private var ratioY:Number;
		
		/**
		 * not needed
		 * @private
		 */
		public static var FingerMotion_Menu:ContextMenu;
		/**
		 * not needed
		 * @private
		 */
		public static var defaultItems:ContextMenuBuiltInItems;
		/**
		 * not needed
		 * @private
		 */
		public static var item:ContextMenuItem;
		private var SITEconteneur:Sprite;
		private var previewCam:Boolean;
		/**
		 * Bitmap that stores the data from your webcam with the fingers motion result. This bitmap is use with the addCameraView() and the removeCameraView() method.
		 * @private
		 */ 
		public var imageView:Bitmap; 
		private var scaleFactor:Number;
		
		//Interaction Controls
		private var objectsTotal:Array = new Array;
		private var objects:Array = new Array();
		private var overObject:Sprite = new Sprite(); //Array for MouseOver Elements
		private var objectSelect:Sprite; 
		private var clickLaunch:Boolean = true;
		
		private var overlay:Sprite = new Sprite();
		private var boxAlert:Sprite = new Sprite();
		[Embed(source="img/yes.png")]
		private var yes:Class;
		[Embed(source="img/no.png")]
		private var no:Class;
		[Embed(source="img/yes_hover.png")]
		private var yes_hover:Class;
		[Embed(source="img/no_hover.png")]
		private var no_hover:Class;
		
		/**
		 * This method provides all you need to start the navigation system. 
		 * 
		 * @param conteneurSprite This is the container that you must specified to apply the detection on it. Each Object in this container can interact with the FingresMotionEvent class.
		 * @param markerVisibility Allow you to enable/disable the default marker representation on the screen, set it to true : display 3 circles that represent the position of each marker.
		 * @param previewCamera Allow you to enable/disable the camera display box placed in the bottom right corner of your animation. 
		 * @param previewCameraWidth define the width of the preview.
		 * @param previewCameraHeight define the height of the preview.
		 * 
		 * @example This example show you a simple way to start the Fingers Motion System :
		 * 
		 * <p>Assuming that your application is in the mainContainer sprite</p>
		 * <listing version="3.0">
		 * var myNavigation:FingersMotion = new fingersMotion(mainContainer,true,true);
		 * addChild(myNavigation);
		 * </listing> 
		 * <p>Note that you must have your navigation above your container in the DisplayList.</p>
		 * 
		 * @see FingersMotionEvent#FingersMotionEvent() How to use FingersMotionEvents
		 * @see setupFingers Fingers Motion Setup Panel
		 */
		public function fingersMotion(conteneurSprite:Sprite, markerVisibility:Boolean=true, previewCamera:Boolean=false, previewCameraScaleFactor:Number=1):void {
			
			addEventListener(Event.ADDED_TO_STAGE,activation);
			markersVisibility = markerVisibility
			SITEconteneur = conteneurSprite;
			previewCam = previewCamera;
			scaleFactor = previewCameraScaleFactor;
		}
		/**
		 * not needed
		 * @private
		 */	
		public function activation(evt:Event):void {
			
			//START Context Menu
			
			
			stage.addEventListener(Event.RESIZE, resizing);
			setupXpos = (stage.stageWidth/2)-310;
			setupYpos = (stage.stageHeight/2)-225;
			          
						
		
			
			
			
			
			//END CONTEXT MEN
			
			// Webcam init + Capture image
			
			webcam = Camera.getCamera();
			webcam.addEventListener(StatusEvent.STATUS, denyCam );
			webcam.setMode( 320, 240, 30 );
			webcam.addEventListener(ActivityEvent.ACTIVITY, activityHandler);
			vid = new Video(320, 240);
			vid.attachCamera(webcam);
			//matrice flip
			flip.translate( -320, 0 );
			flip.scale( -1, 1 );
			
			//saturation filter
			a = rwgt + (1 - rwgt) * s;
			b = gwgt * (1 - s);
			c = bwgt * (1 - s);
			d = rwgt * (1 - s);
			e = gwgt + (1 - gwgt) * s;
			f = bwgt * (1 - s);
			g = rwgt * (1 - s);
			h = gwgt * (1 - s);
			i = bwgt + (1 - bwgt) * s;
			satMat = new Array(a, b, c, 0, 0, d, e, f, 0, 0, g, h, i, 0, 0, 0, 0, 0, 1, 0);
			saturate = new ColorMatrixFilter(satMat);
			//addChild(vid);
			

		}
		private function denyCam(e:StatusEvent):void{
			if(e.code == "Camera.Muted"){
				
			overlay.graphics.beginFill(0,0.8);
			overlay.graphics.drawRect(0,0,stage.stageWidth, stage.stageHeight);
			overlay.graphics.endFill();
			var textAlert:TextField = new TextField();
			var formatAlert:TextFormat = new TextFormat();
			formatAlert.font = "arial";
			formatAlert.color = 0xf0f0f0;
			formatAlert.size = 18;
			formatAlert.bold = false;
			textAlert.selectable = false;
			textAlert.multiline = true;
			textAlert.autoSize = "left";
			textAlert.defaultTextFormat = formatAlert;
			textAlert.htmlText = "<p align='center'>You choose to not use your webcam for this website.<br><br><font size='-4'>This website has a great feature that allow you to interact with your hand.<br><font size='-2'> --> See <a href='#' target='_blank'><font color='#009ee0'><u>Fingers Motion</u></font></a> for more information.</font></font><br><br><font size='+4'>Do you want to relaunch the security panel to activate your webcam ?</font></p>";
			boxAlert.addChild(textAlert);
			var conteneurYes:Sprite = new Sprite();
			var conteneurNo:Sprite = new Sprite();
			conteneurYes.buttonMode = true;
			conteneurNo.buttonMode = true;
			var btnYes:Bitmap = new yes();
			conteneurYes.name = "yes";
			conteneurNo.name = "no";
			var btnNo:Bitmap = new no();
			conteneurYes.addChild(btnYes);
			conteneurNo.addChild(btnNo);
			conteneurYes.x = 237.5 ;
			conteneurYes.y = 170;
			conteneurNo.x = 363.5;
			conteneurNo.y = 170;
			conteneurYes.addEventListener(MouseEvent.MOUSE_OVER, AlertPanel);
			conteneurNo.addEventListener(MouseEvent.MOUSE_OVER, AlertPanel);
			conteneurYes.addEventListener(MouseEvent.MOUSE_OUT, AlertPanel);
			conteneurNo.addEventListener(MouseEvent.MOUSE_OUT, AlertPanel);
			conteneurYes.addEventListener(MouseEvent.CLICK, AlertPanel);
			conteneurNo.addEventListener(MouseEvent.CLICK, AlertPanel);
			boxAlert.addChild(conteneurYes);
			boxAlert.addChild(conteneurNo);
			boxAlert.x = stage.stageWidth/2 - boxAlert.width/2;
			boxAlert.y = stage.stageHeight/2 - boxAlert.height/2;
			overlay.addChild(boxAlert);
			addChild(overlay);
			}
			webcam.removeEventListener(StatusEvent.STATUS, denyCam );
		}
		private function AlertPanel(e:MouseEvent):void{
			trace (e.type);
			switch(e.type){
				case "mouseOver":
					switch (e.target.name){
						case "yes":
							e.target.removeChildAt(0);
							var hoverYes:Bitmap = new yes_hover();
							e.target.addChild(hoverYes);
							break;
						case "no":
							e.target.removeChildAt(0);
							var hoverNo:Bitmap = new no_hover();
							e.target.addChild(hoverNo);
							break;
						
					}
					break;
				case "mouseOut":
					switch (e.target.name){
						case "yes":
							e.target.removeChildAt(0);
							var outYes:Bitmap = new yes();
							e.target.addChild(outYes);
							break;
						case "no":
							e.target.removeChildAt(0);
							var outNo:Bitmap = new no();
							e.target.addChild(outNo);
							break;
						
					}
					break;
				case "click":
					switch (e.target.name){
						case "yes":
							Security.showSettings(SecurityPanel.PRIVACY)
							overlay.parent.removeChild(overlay);
							break;
						case "no":
							
							overlay.parent.removeChild(overlay);
							break;
						
					}
					break;
			}
		}
		
		private function resizing(e:Event):void{
			setupXpos = (stage.stageWidth/2)-310;
			setupYpos = (stage.stageHeight/2)-232.5;
			ratioX = stage.stageWidth / 320;
			ratioY = stage.stageHeight/240;
			setupFingers.MySetup.x = setupXpos;
			setupFingers.MySetup.y = setupYpos;
			setupFingers.bgPanel.graphics.clear();
			setupFingers.bgPanel.graphics.beginFill(0xFFFFFF,0.1);
			setupFingers.bgPanel.graphics.drawRect(0,0,stage.stageWidth,stage.stageHeight);
			setupFingers.bgPanel.graphics.endFill();
			if(previewCam){
				if(cameraViewAutoResize){
				if(imageView is DisplayObject){
					
				imageView.x = stage.stageWidth - imageView.width;
				imageView.y = stage.stageHeight - imageView.height;
				
				}
				}
				
		}
			overlay.graphics.clear();
			overlay.graphics.beginFill(0,0.8);
			overlay.graphics.drawRect(0,0,stage.stageWidth, stage.stageHeight);
			overlay.graphics.endFill();
			boxAlert.x = stage.stageWidth/2 - boxAlert.width/2;
			boxAlert.y = stage.stageHeight/2 - boxAlert.height/2;		
		}
		private function setupPanelFingers(e:ContextMenuEvent):void {
			switch(e.target.caption){
				case "Open Fingers Motion Setup":
					trace("menu1");
					if(!webcam.muted){
						var setupFingers1:setupFingers = new setupFingers(setupXpos, setupYpos);
						setupFingers1.name = "SetupFingers1Active";
									
						addChild(setupFingers1);
						switchCustomMenuItems("Open Fingers Motion Setup", "Close Fingers Motion Setup");
					}else{
						trace("webcam off");
					}
					break;
				case "Close Fingers Motion Setup":
					var del:Sprite = Sprite(getChildByName("SetupFingers1Active"));
					del.addEventListener(Event.REMOVED_FROM_STAGE, resetSetup);
					removeChild(del);
					
				case "Activate Fingers Motion":
					trace("menu2");
					break;
			}
			
		}
		/**
		 * not needed
		 * @private
		 */
		public static function resetSetup(e:Event):void{
			switchCustomMenuItems("Close Fingers Motion Setup", "Open Fingers Motion Setup");
		}
		private function removeDefaultItems():void {
			FingerMotion_Menu.hideBuiltInItems();
			defaultItems = FingerMotion_Menu.builtInItems;
			defaultItems.print = true;
		}
		private function addCustomMenuItems(menuLabel:String):void {
			item = new ContextMenuItem(menuLabel);
			FingerMotion_Menu.customItems.push(item);
			item.addEventListener(ContextMenuEvent.MENU_ITEM_SELECT, setupPanelFingers);
		}
		/**
		 * This method allow you to switch the state of the FingersMotionMenu Item.
		 * 
		 * @param menuLabel The actual menuItem you want to switch. The value expected can only be "Open Fingers Motion Setup" or "Close Fingers Motion Setup"
		 * @param newMenuLabel the new menuItem name you want. The value expected can only be "Open Fingers Motion Setup" or "Close Fingers Motion Setup"
		 * 
		 * <p>If you want add more Items edit the class fingersMotion.as see lines 406 to 478 </p>
		 * 
		 * @example switch menuItem :
		 * <listing version="3.0">
		 * switchCustomMenuItems("Open Fingers Motion Setup", "Close Fingers Motion Setup");
		 * </listing>
		 * 
		 */
		public static function switchCustomMenuItems(menuLabel:String, newMenuLabel:String):void {
			var array:Array = FingerMotion_Menu.customItems;
			
			for (var i:int=0; i<array.length; ++i){
				if(array[i].caption == menuLabel){
					array[i].caption = newMenuLabel;
				}
				
			}
			FingerMotion_Menu.customItems = array;
			//InteractiveObject(root).contextMenu = FingerMotion_Menu;
			//item = new ContextMenuItem(menuLabel);
			//FingerMotion_Menu.customItems.push(item);
			//item.addEventListener(ContextMenuEvent.MENU_ITEM_SELECT, setupPanelFingers);
		}
		private function activityHandler(evt:ActivityEvent):void 
		{
			FingerMotion_Menu = new ContextMenu();
			removeDefaultItems();
			addCustomMenuItems("Open Fingers Motion Setup");
			addCustomMenuItems("Activate Fingers Motion");
			InteractiveObject(root).contextMenu = FingerMotion_Menu;
			image = new BitmapData(320, 240, false);
			//image1 = new BitmapData(320, 240, false, 0xFF000000);
			//image2 = new BitmapData(320, 240, false, 0xFF000000);
			//image3 = new BitmapData(320,2540, false, 0xFF000000),
			imageB = new Bitmap(image);
			
			
			//imageO = new Bitmap(image);
			//imageF = new BitmapData(320, 240, true );
			//temp = new Bitmap(imageF);
			if (!webcam.muted) 
			{
				trace("Webcam is on");
				//affichage image capturée
				
				sphere1.graphics.beginFill(0x0000FF);
				sphere1.graphics.drawCircle(-3, -3,6);
				sphere1.graphics.endFill();
				
				sphere2.graphics.beginFill(0xFFFF00);
				sphere2.graphics.drawCircle(-3, -3,6);
				sphere2.graphics.endFill();
				
				sphere3.graphics.beginFill(0x00FF00);
				sphere3.graphics.drawCircle(-3, -3,6);
				sphere3.graphics.endFill();
				
				
				//lancement du timer de capture
				/*var tempo:Timer = new Timer(20);
				tempo.addEventListener(TimerEvent.TIMER, tempoHandler);
				tempo.start();*/
				
				t.addEventListener(TimerEvent.TIMER, timerHandler);
				t.start();
				//addEventListener(Event.ENTER_FRAME,timerHandler);
				if(previewCam){
					if(imageView is DisplayObject)
					{
						
					}else{
					imageView = new Bitmap(image);
					imageView.scaleX = imageView.scaleY = scaleFactor;
					imageView.x = stage.stageWidth - imageView.width;
					imageView.y = stage.stageHeight - imageView.height;
					
					addChild(imageView);
					}
				}
				//image.draw(vid, flip);
				//image1.draw(vid, flip);
				if(markersVisibility){
				addChild(sphere1);
				addChild(sphere2);
				addChild(sphere3);
				}
				ratioX = stage.stageWidth / 320;
				ratioY = stage.stageHeight/240;
			}
			webcam.removeEventListener(ActivityEvent.ACTIVITY, activityHandler);
			
		}
		
		/**
		 * this method add the cameraView in the bottom right corner of your application.
		 * 
		 * @param scaleFactor set the scale of the bitmap ( size is 320 x 240 ).
		 * @param posX the position X of the bitmap. If set to -100 (by default) the bitmap will be placed on the right of your application. 
		 * @param posY the position Y of the bitmap. If set to -100 (by default) the bitmap will be placed on the bottom of your application. 
		 */
		private var cameraViewAutoResize:Boolean = true;
		public function addCameraView(scaleFactor:Number=1,posX:int=-100,posY:int=-100):void{
			if(!previewCam){
			imageView = new Bitmap(image);
			imageView.scaleX = imageView.scaleY = scaleFactor;
			if(posX == -100){
			imageView.x = stage.stageWidth - imageView.width;
			}else{
				imageView.x = posX;
				cameraViewAutoResize = false;
			}
			if(posY == -100){
			imageView.y = stage.stageHeight - imageView.height;
			}else{
				imageView.y = posY;
				cameraViewAutoResize = false;
			}
			addChild(imageView);
			previewCam = true;
			}
		}
		/**
		 * this method remove the cameraView only if you have already it in the DisplayList.
		 * 
		 */
		public function removeCameraView():void{
			if(previewCam){
			imageView.parent.removeChild(imageView);
			previewCam = false;
			}
		}
		private function timerHandler(evt:TimerEvent):void
		{
			//DETECTION MOUVEMENT
			/*var comparaison:BitmapData = image.compare(image1) as BitmapData;
			var Bmpdiff:Bitmap = new Bitmap(comparaison);
			imageR.draw(Bmpdiff);
			imageR.applyFilter(imageR, rect, pt, saturateGray);//filtre saturation
			imageR.applyFilter(imageR, rect, pt, filter);//filtre blur
			imageR.threshold(imageR, rect, pt, "<", 0xFFAAAAAA , 0xFF000000, 0xFFFFFFFF, true);
			imageR.threshold(imageR, rect, pt, ">", 0xFFCCCCCC, 0xFFFFFFFF, 0xFFFFFFFF, true);
			//RECTANGLE ZONE MOUVEMENT
			rectPoint = imageR.getColorBoundsRect(0xFFFFFFFF, 0xFFFFFFFF, true);
			rectangle.graphics.clear();
			rectangle.graphics.lineStyle(2, 0x0000FF);
			rectangle.graphics.drawRect((rectPoint.x + 320), (rectPoint.y + 80), rectPoint.width, rectPoint.height);
			*/
			//DETECTION COULEUR 
			//var rectCouleur:Rectangle = new Rectangle(rectPoint.x, rectPoint.y, rectPoint.width, rectPoint.height);
			//var ptCouleur:Point = new Point(rectPoint.x, rectPoint.y);
			image.draw(vid, flip);
			
			
			image.applyFilter(image, rect, pt, filter);//filtre blur
			image.applyFilter(image, rect, pt, saturate);//filtre blur
			
			if (!initCapteur1) {
				//For in Vector Techniques
				image.lock();
				for (var ab:* in colorCapteur1) {
					image.threshold(image,rect,pt,"==",colorCapteur1[ab],0xFF0000FF, 0x00FFFFFF, true); 
				}
				image.unlock();
				
			}
			if (!initCapteur2) {
				//For in Vector Techniques
				image.lock();
				for (var cd:* in colorCapteur2) {
					image.threshold(image,rect,pt,"==",colorCapteur2[cd],0xFFFFFF00, 0x00FFFFFF, true); 
				}
				image.unlock();
				
			}
			
			if (!initCapteur3) {
				//For in Vector Techniques
				image.lock();
				for (var ef:* in colorCapteur3) {
					image.threshold(image,rect,pt,"==",colorCapteur3[ef],0xFF00FF00, 0x00FFFFFF, true); 
				}
				image.unlock();
				
			}
		
			
			rectPointF = image.getColorBoundsRect(0xFFFFFFFF, 0xFF0000FF, true);
			capteur1Orig = getCenter(rectPointF.x*ratioX, rectPointF.y*ratioY, rectPointF.width, rectPointF.height);
			
			rectPointG = image.getColorBoundsRect(0xFFFFFFFF, 0xFFFFFF00, true);
			capteur2Orig = getCenter(rectPointG.x*ratioX, rectPointG.y*ratioY, rectPointG.width, rectPointG.height);
			
			rectPointH = image.getColorBoundsRect(0xFFFFFFFF, 0xFF00FF00, true);
			capteur3Orig = getCenter(rectPointH.x*ratioX, rectPointH.y*ratioY, rectPointH.width, rectPointH.height);
			
			
			
			if(markersVisibility){
			sphere1.x = capteur1Orig.x;
			sphere1.y = capteur1Orig.y;
			sphere2.x = capteur2Orig.x;
			sphere2.y = capteur2Orig.y;
			sphere3.x = capteur3Orig.x;
			sphere3.y = capteur3Orig.y;
			}
			//Point and Controls Events
			//var PointCapteurPrincipale:Point = new Point(sphere2.x,sphere2.y);
			
			objects = SITEconteneur.getObjectsUnderPoint(capteur2Orig);
			//trace (objectsTotal.length);
			
			
			//trace( "FILTRER : "+objects);
			var id:int = objects.length;
			var customEvent:FingersMotionEvent;
			//Controls
			if( id !== 0 ){
				
			//Filter Array :
				var temp:DisplayObject;
				/*
				if(objects[id-1] is Sprite && objects[id-1].hasEventListener("fmActive")){
					
					objectSelect = objects[id-1];
					
				}else{
					if(objects[id-1].parent){
						temp = objects[id-1];
						
						do { temp = temp.parent}while(temp.parent && (!temp is Sprite))
						if(temp.hasEventListener("fmActive")){
							objectSelect = Sprite(temp);
							
						}else{
							objectSelect = null;
						}
					}else{
						objectSelect = null;
					}
					
				};*/
				
				switch(objects[id-1].hasEventListener("fmActive")){
					case true:
						objectSelect = objects[id-1];
						break;
					case false:
						if(objects[id-1].parent){
							temp = objects[id-1];
							do { temp = temp.parent}while(temp.parent && !temp is Sprite);
							switch(temp.hasEventListener("fmActive")){
								case true:
									objectSelect = Sprite(temp);
									break;
								case false:
									do { temp = temp.parent}while(temp.parent && !temp is Sprite);
									switch(temp.hasEventListener("fmActive")){
										case true:
											objectSelect = Sprite(temp);
											break;
										case false:
									objectSelect = null;
									break;
									}
									break;
							}
						}else{
							objectSelect = null;
							break;	
							}	
						break;
				}
		  	/*if(objectSelect !== null){
			trace("SELECT : "+objectSelect.name);
			}else{
				trace("SELECT : null");
			}*/
			//Mouse Over
			switch (fingersMotionStatut){
				case 1:
					//mouseOut
					if(overObject !== objectSelect){
						customEvent = new FingersMotionEvent(FingersMotionEvent.FM_OUT);
						overObject.dispatchEvent(customEvent);
						fingersMotionStatut = 0;
						break;
					}
					
					
					
					// Drag and Drop 
					if(capteur1Orig.x !== 0 && capteur1Orig.y !== 0 && overObject.hasEventListener("fmDragAndDrop") ){
						customEvent = new FingersMotionEvent(FingersMotionEvent.FM_DRAG_AND_DROP);
						overObject.dispatchEvent(customEvent);
						fingersMotionStatut = 2;
						break;
					}
					//Click 
					if(capteur3Orig.x !== 0 && capteur3Orig.y !== 0 && overObject.hasEventListener("fmClick")){
						customEvent = new FingersMotionEvent(FingersMotionEvent.FM_CLICK);
						overObject.dispatchEvent(customEvent);
						fingersMotionStatut = 3;
						break;
					}
					
				case 2:
					if(capteur1Orig.x == 0 && capteur1Orig.y ==0){
						customEvent = new FingersMotionEvent(FingersMotionEvent.FM_HOVER);
						overObject.dispatchEvent(customEvent);
						fingersMotionStatut = 1;
						break;
					}else{
						if(capteur2Orig.x == 0 && capteur2Orig.y ==0){
							customEvent = new FingersMotionEvent(FingersMotionEvent.FM_HOVER);
							overObject.dispatchEvent(customEvent);
							fingersMotionStatut = 1;
							break;
						}
						customEvent = new FingersMotionEvent(FingersMotionEvent.FM_DRAG_AND_DROP);
						overObject.dispatchEvent(customEvent);
						if(capteur3Orig.x !== 0 && capteur3Orig.y !== 0 && overObject.hasEventListener("fmRotation")){
							var angleDrag:Number = getAngle(capteur2Orig,capteur3Orig);
							customEvent = new FingersMotionEvent(FingersMotionEvent.FM_ROTATION,-angleDrag);
							overObject.dispatchEvent(customEvent);
							break;
						}
					}
				    break;
				case 3 : 
					if(capteur3Orig.x == 0 && capteur3Orig.y == 0 ){
						customEvent = new FingersMotionEvent(FingersMotionEvent.FM_HOVER);
						overObject.dispatchEvent(customEvent);
							fingersMotionStatut = 1;
							break;
					}
					break;
				
				default:
					
					if(objectSelect !== null && objectSelect.hasEventListener("fmHover")){
						overObject = objectSelect;
						customEvent = new FingersMotionEvent(FingersMotionEvent.FM_HOVER);
						overObject.dispatchEvent(customEvent);
						fingersMotionStatut = 1;
					}
					
			}
			
			}
			
			
			
			
			
		}
		
		private function isFmActive(element:*, index:int, arr:Array):Boolean{
			
			return true;
							
		}
		
		private function getCenter(x:int, y:int, width:int, height:int):Point{
			var center:Point = new Point( x + (width/2), y+ (height/2));
			return center;
		}
		
		private function getAngle(ptna:Point, ptnb:Point):Number{
			var ca:Number;
			ca = (ptnb.y - ptna.y)/(ptnb.x - ptna.x);
			
			if(ptnb.y > ptna.y){
				ca = Math.atan(Math.abs(ca))/Math.PI *-180;
				if(ptnb.x < ptna.x){
					
					ca = -180 + Math.abs(ca);
				}
			}else{
				ca = Math.atan(Math.abs(ca))/Math.PI *180;				
				if(ptnb.x < ptna.x){
					ca =180-ca;
				}
			}
			return ca;
		}
		//Public Function to use it
		/**
		 * This method allow you to get the position of the markers as an object.
		 *  
		 * <p>Markers (Object) contains three Point</p>
		 * <ul>
		 * <li>blue : the blue's marker Point</li>
		 * <li>yellow : the yellow's marker Point</li>
		 * <li>green : the green's marker Point</li>
		 * </ul>
		 * 
		 * @example Simple use to show you how to handle with it :
		 * <listing version="3.0">
		 * //Start FingersMotion
		 * var myNavigation:FingersMotion = new fingersMotion(mainContainer,true,true);
		 * addChild(myNavigation);
		 * 
		 * //Create an Object "markers" and get the position of the markers
		 * var markers:Object = myNavigation.getMarkers();
		 * trace("blueX : "+markers.blue.x+" blueY : "+markers.blue.y);
		 * //OUTPUT => blueX : 120 blueY : 30
		 * </listing>
		 *  
		 */
		
		public function getMarkers():Object{
			var markers:Object = new Object();
			markers.blue = capteur1Orig;
			markers.yellow = capteur2Orig;
			markers.green = capteur3Orig;
			
			return markers;
		}
		/**
		 * This method allow you to get the sprite markers as an object.
		 *  
		 * <p>DisplayMarkers (Object) contains three Sprite.</p>
		 * <p>Don't Work if you have set markerVisibility:Boolean to false.</p> 
		 * <ul>
		 * <li>blue : the blue's marker Sprite</li>
		 * <li>yellow : the yellow's marker Sprite</li>
		 * <li>green : the green's marker Sprite</li>
		 * </ul>
		 * 
		 * @example Simple use to show you how to handle with it :
		 * <listing version="3.0">
		 * //Start FingersMotion
		 * var myNavigation:FingersMotion = new fingersMotion(mainContainer,true,true);
		 * addChild(myNavigation);
		 * 
		 * //Create an Object "markers" 
		 * var markers:Object = myNavigation.getDisplayMarkers();
		 * trace(markers.blue);
		 * //OUTPUT => Object Sprite
		 * </listing>
		 *  
		 */
		public function getDisplayMarkers():Object{
			var markers:Object = new Object();
			markers.blue = sphere1;
			markers.yellow = sphere2;
			markers.green = sphere3;
			
			return markers;
		}
		
	}
	
}