package com.dipigraphics.fingersMotion
{
	import fl.controls.Button;
	import fl.controls.Label;
	import fl.controls.Slider;
	import fl.controls.SliderDirection;
	import fl.events.SliderEvent;
	
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Graphics;
	import flash.display.Loader;
	import flash.display.MovieClip;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.events.ActivityEvent;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.TimerEvent;
	import flash.filters.BlurFilter;
	import flash.filters.ColorMatrixFilter;
	import flash.filters.DropShadowFilter;
	import flash.geom.Matrix;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.media.Camera;
	import flash.media.Video;
	import flash.net.URLRequest;
	import flash.text.AntiAliasType;
	import flash.text.Font;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFieldType;
	import flash.text.TextFormat;
	import flash.ui.Mouse;
	import flash.utils.Timer;

	/**
	 * This class provides the setup panel accessible via the context Menu.
	 * 
	 * <p>Created by Denis Pissoort</p>
	 * <p>Produced by <a href="http://www.infographie-sup.be">Haute Ecole Albert Jacquard</a></p>
	 * <p>Email : denis&#64;dipi-graphics.com</p>
	 * <p>HomePage of the project : <a href="http://www.dipi-graphics.com/TFE/project/">Fingers Motion Project HomePage</a></p>
	 * <p>This software is licensed under the <a href="http://creativecommons.org/licenses/GPL/2.0/">CC-GNU GPL</a> version 2.0 or later.</p>
	 * 
	 */ 
	public class setupFingers extends Sprite
	{
		//Main Conteneur
		/**
		 * not needed
		 * @private
		 */
		public static var MySetup:Sprite = new Sprite();
		/**
		 * not needed
		 * @private
		 */
		public static var bgPanel:Sprite = new Sprite();
		//Main Display
		
		//Main Constante
		//var rect:Rectangle = new Rectangle(0,0,320,240);
		//var pt:Point = new Point(0, 0);
		//var rectPoint:Rectangle;
		private var rectPointF:Rectangle;
		private var rectPointG:Rectangle;
		private var rectPointH:Rectangle;
		//Image Capture
		//var imageB:Bitmap;
		//var image:BitmapData;
		
		
		//Rectangle Capteurs 
		private var rectangle1:Shape = new Shape();//zone rectangle de detection Couleur
		private var rectangle2:Shape = new Shape();//zone rectangle de detection Couleur
		private var rectangle3:Shape = new Shape();//zone rectangle de detection Couleur
		
		//OUTILS 
		private var blurSlider:Slider = new Slider();
		private var blurLabel:Label = new Label()
		private var blurText:TextField = new TextField();
		private var saturationSlider:Slider = new Slider();
		private var saturationLabel:Label = new Label();
		private var saturationText:TextField = new TextField();
		//Timer
		private var t:Timer = new Timer(40);
		
		//capteur
		private var capteur1:Boolean = true;
		private var initCapteur1:Boolean = true;
		
		private var hslColorCapteur1:Object = new Object();
		
		private var capteur2:Boolean = false;
		private var initCapteur2:Boolean = true;

		private var hslColorCapteur2:Object = new Object();
		
		private var capteur3:Boolean = false;
		private var initCapteur3:Boolean = true;
		
		private var hslColorCapteur3:Object = new Object();
		
		private var bgSetup:Loader = new Loader();
		private var mainImage:Loader = new Loader();
		
		private var selectCapteur1:Sprite= new Sprite();
		private var selectCapteur2:Sprite= new Sprite();
		private var selectCapteur3:Sprite= new Sprite();
		
		//filtre
		//blur
		//private var flou:int = 5;
		//private var filter:BlurFilter = new BlurFilter(flou,flou,2);
		
		//saturation
		
		private var rwgt:Number = .3086;
		private var gwgt:Number = .6094;
		private var bwgt:Number = .0820;
		private var a:Number;
		private var b:Number;
		private var c:Number;
		private var d:Number;
		private var e:Number;
		private var f:Number;
		private var g:Number;
		private var h:Number;
		private var i:Number;
		private var satMat:Array = new Array(a,b,c,0,0,d,e,f,0,0,g,h,i,0,0, 0, 0, 0, 1, 0);
		
		
		
		//Tolerance
		private var tol:int;
		private var hueToleranceSlider:Slider = new Slider();
		private var hueToleranceLabel:Label = new Label()
		private var hueToleranceText:TextField = new TextField();
		private var satToleranceSlider:Slider = new Slider();
		private var satToleranceLabel:Label = new Label()
		private var satToleranceText:TextField = new TextField();
		private var lumToleranceSlider:Slider = new Slider();
		private var lumToleranceLabel:Label = new Label()
		private var lumToleranceText:TextField = new TextField();
		
		private var startHue:int;
		private var endHue:int;
		private var startSat:int;
		private var endSat:int;
		private var startLum:int;
		private var endLum:int;
		
		private var nbreRange:TextField = new TextField();
		
		
		//PICKER TOOLS
		private var conteneur:Sprite;
		private var colorPick:uint;
		private var cadrePick:Sprite = new Sprite();
		private var hexaColor:TextField = new TextField();
		private var hexaRect:Sprite = new Sprite();
		private var hueColor:TextField = new TextField();
		private var btnClose:Sprite = new Sprite();
		private var ok:Sprite = new Sprite();
		
		//Font
		
		[Embed(source="librairy/btnOk.swf", symbol="btnOk")]
		private var boutonOk:Class;
		
		[Embed(source="img/check.png")]
		private var check:Class;
		
		private var format:TextFormat = new TextFormat();
		private var btnOk:MovieClip = new boutonOk();
		
		private var checked1:Bitmap = new check();
		private var checked2:Bitmap = new check();
		private var checked3:Bitmap = new check();
		
		private var enableCapteur1:Sprite = new Sprite();
		private var enableCapteur2:Sprite = new Sprite();
		private var enableCapteur3:Sprite = new Sprite();
		/**
		 * This method create the Setup Panel for the Fingers Motion System
		 * 
		 * @param setupPosX positionX of the top left corner of the panel
		 * @param setupPosY positionY of the top left corner of the panel
		 * 
		 * <p>By default this panel is accessible via the contextMenu and it is display in the center of your application if you use :<br><br>
		 * stage.scaleMode = StageScaleMode.NO_SCALE<br>
		 * stage.align = StageAlign.TOP_LEFT<br><br>
		 * Other mode can be produced bad result.
		 * </p>
		 */
		public function setupFingers(setupPosX:Number, setupPosY:Number)
		{
		 
			
		 addChild(bgPanel);
		 MySetup.x = setupPosX;
		 MySetup.y = setupPosY;
		 //MySetup.width = 640;
		 //MySetup.height = 580;
		 MySetup.scaleX = MySetup.scaleY = 1;
		 addChild(MySetup);
		 var bgSetup:Shape = new Shape();
		 var colors:Array = [0xf8f8f8, 0xd8d8d8];
		 var alphas:Array = [1, 1];
		 var ratios:Array = [0, 255];
		 bgSetup.graphics.lineStyle(2,0xFFcccccc);
		 bgSetup.graphics.beginGradientFill("linear",colors,alphas,ratios,null,"pad","linearRgb",1);
		 bgSetup.graphics.drawRoundRect(0,0,465,620,10);
		 bgSetup.graphics.endFill();
		 bgSetup.rotation =90;
		 bgSetup.x = 620;
		
		 var dropShadow:DropShadowFilter = new DropShadowFilter(10,45,0,0.3,6,6);
		 var filtersArray:Array = [dropShadow];
         MySetup.filters = filtersArray;
		 MySetup.addChild(bgSetup);
		 addEventListener(Event.ADDED_TO_STAGE,activation);
		 
		 //Init Outils
		 //const Slider Blur et Slider Saturation
		 
		 format.font = "Arial";
		 format.color = 0x000000;
		 format.size = 11;
		 format.bold = true;
		 
		 var formatTitre:TextFormat = new TextFormat();
		 formatTitre.font = "arial";
		 formatTitre.color = 0xf0f0f0;
		 formatTitre.size = 18;
		 formatTitre.bold = false;
		
		 
		 
		 //BLUR FILTER						    //SATURATION FILTER
		 blurText.defaultTextFormat = format;	saturationText.defaultTextFormat = format;		
		 blurText.text = "Blur Level";			saturationText.text = "Saturation Level";
		 blurText.selectable=false;				saturationText.selectable=false;
		 blurText.x = 50;						saturationText.x = 50;
		 blurText.y = 325;						saturationText.y = 360;
		 blurSlider.x = 50;						saturationSlider.x = 50;
		 blurSlider.y = 345;						saturationSlider.y = 380;
		 blurSlider.width = 200;					saturationSlider.width = 200;
		 blurSlider.height = 20;					saturationSlider.height = 20;
		 blurSlider.maximum = 100;				saturationSlider.maximum = 200;
		 blurSlider.minimum = 0;					saturationSlider.minimum = 0;
		 blurSlider.value = fingersMotion.flou*5;	saturationSlider.value = int(fingersMotion.s*50);
		 blurLabel.text = fingersMotion.flou*5+"%";	saturationLabel.text = int(fingersMotion.s*50)+"%";
		 blurLabel.x = 260;						saturationLabel.x = 260;
		 blurLabel.y = 340;						saturationLabel.y = 375;
		 
		 //Title bar
		 var titre:TextField = new TextField();
		 
		 titre.x = 10;
		 titre.y = 3;
		 titre.wordWrap = false;
		 titre.autoSize = TextFieldAutoSize.LEFT;
		 titre.antiAliasType = AntiAliasType.ADVANCED;
		 titre.text="Fingers Motion Setup";
		 var eurostyleFormat:TextFormat = new TextFormat("arial",18,0xf0f0f0);
		 titre.setTextFormat(eurostyleFormat);
		 var styleBar:Shape = new Shape();
		 styleBar.graphics.beginFill(0x4b4b4b);
		 styleBar.graphics.drawRect(0,0,620,30);
		 styleBar.x = 0;
		 styleBar.y = 0;
		 var maskBar:Shape = new Shape();
		 maskBar.graphics.beginFill(0);
		 maskBar.graphics.drawRoundRect(0,0,620,450,10);
		 MySetup.addChild(maskBar);
		 styleBar.mask = maskBar;
		 MySetup.addChild(styleBar);
		 MySetup.addChild(titre);
		 
		 btnClose.graphics.beginFill(0x666666);
		 btnClose.graphics.drawCircle(0,0,10);
		 btnClose.graphics.endFill();
		 var Xclose:TextField = new TextField();
		 Xclose.x =-7.15;
		 Xclose.y =-14;
		 Xclose.embedFonts = true;
		 Xclose.autoSize = TextFieldAutoSize.LEFT;
		 Xclose.antiAliasType = AntiAliasType.ADVANCED;
		 Xclose.text ="x";
		 var eurostyleFormat1:TextFormat = new TextFormat("arial",16,0xf0f0f0);
		 Xclose.setTextFormat(eurostyleFormat1);
		 Xclose.selectable=false;
		 btnClose.addChild(Xclose);
		 var zoneBtnClose:Sprite = new Sprite();
		 zoneBtnClose.graphics.beginFill(0,0);
		 zoneBtnClose.graphics.drawCircle(0,0,10);
		 zoneBtnClose.graphics.endFill();
		 zoneBtnClose.buttonMode = true;
		 btnClose.addChild(zoneBtnClose);
		 btnClose.x = 605;
		 btnClose.y = 15;
		 MySetup.addChild(btnClose);
		 btnClose.addEventListener(MouseEvent.MOUSE_OVER,closePanel);
		 btnClose.addEventListener(MouseEvent.MOUSE_OUT,closePanel);
		 btnClose.addEventListener(MouseEvent.CLICK,closePanel);
		 btnOk.addEventListener(MouseEvent.MOUSE_OVER,closePanelok);
		 btnOk.addEventListener(MouseEvent.MOUSE_OUT,closePanelok);
		 btnOk.addEventListener(MouseEvent.CLICK,closePanelok);
		 btnOk.gotoAndStop(1);
		 btnOk.x = 565;
		 btnOk.y = 430;
		 btnOk.buttonMode = true;
		 MySetup.addChild(btnOk);
		 
		 
		 //End Title Bar
		 
		 var Explication:TextField = new TextField();
		 Explication.defaultTextFormat = format;
		 Explication.x = 10;
		 Explication.y = 34.7;
		 Explication.width = 355;
		 Explication.multiline = true;
		 Explication.wordWrap = true;
		 Explication.text ="1) Set the Global Blur and Saturation Slider.\n2) Pick your color's marker and adjust his hue and luminance."
		 MySetup.addChild(Explication);
		 MySetup.addChild(blurText);
		 MySetup.addChild(blurSlider);
		 MySetup.addChild(blurLabel);
		 MySetup.addChild(saturationText);
		 MySetup.addChild(saturationSlider);
		 MySetup.addChild(saturationLabel);
		 
		 blurSlider.addEventListener(SliderEvent.CHANGE, blurHandler);
		 saturationSlider.addEventListener(SliderEvent.CHANGE, saturationHandler);
		 
		 //Hue Tolerance FILTER						   
		 hueToleranceText.defaultTextFormat = format;		
		 hueToleranceText.text = "Hue Tolerance";	    
		 hueToleranceText.selectable=false;				
		 hueToleranceText.x = 360;						
		 hueToleranceText.y = 325;						
		 hueToleranceSlider.x = 360;						
		 hueToleranceSlider.y = 345;						
		 hueToleranceSlider.width = 200;					
		 hueToleranceSlider.height = 20;					
		 hueToleranceSlider.maximum = 200;				
		 hueToleranceSlider.minimum = 0;					
		 hueToleranceSlider.value = fingersMotion.hueTol1;					
		 hueToleranceLabel.text = hueToleranceSlider.value+"° deg";			   
		 hueToleranceLabel.x = 570;						
		 hueToleranceLabel.y = 340;						
		 hueToleranceSlider.name = "hueSlider";          
		 
		 //Lum Tolerance FILTER						    
		 lumToleranceText.defaultTextFormat = format;
		 lumToleranceText.text = "Lum Tolerance";
		 lumToleranceText.selectable=false;
		 lumToleranceText.x = 360;
		 lumToleranceText.y = 360;
		 lumToleranceSlider.x = 360;
		 lumToleranceSlider.y = 380;
		 lumToleranceSlider.width = 200;
		 lumToleranceSlider.height = 20;
		 lumToleranceSlider.maximum = 10;
		 lumToleranceSlider.minimum = 0;
		 lumToleranceSlider.value = fingersMotion.lumTol1;
		 lumToleranceLabel.text = lumToleranceSlider.value+"";
		 lumToleranceLabel.x = 570;
		 lumToleranceLabel.y = 375;
		 lumToleranceSlider.name = "lumSlider";
		 
		 nbreRange.defaultTextFormat = format;
		 nbreRange.selectable = false;
		 nbreRange.autoSize = TextFieldAutoSize.LEFT;
		 nbreRange.text = "Nombre de couleurs à détecter : "+fingersMotion.colorCapteur1.length;
		 nbreRange.x = 360;
		 nbreRange.y = 407.3;
		 MySetup.addChild(nbreRange);
		 
		 MySetup.addChild(hueToleranceText);
		 MySetup.addChild(hueToleranceSlider);
		 MySetup.addChild(hueToleranceLabel);
		 
		 MySetup.addChild(lumToleranceText);
		 MySetup.addChild(lumToleranceSlider);
		 MySetup.addChild(lumToleranceLabel);
		 
		 hueToleranceSlider.addEventListener(SliderEvent.CHANGE, tolerance);
		
		 lumToleranceSlider.addEventListener(SliderEvent.CHANGE, tolerance);
		 
		 
		 //PICKER TOOLS
		 var infoPick:TextField=new TextField();
		 infoPick.defaultTextFormat = format;
		 infoPick.autoSize = TextFieldAutoSize.LEFT;
		 infoPick.x = 400;
		 infoPick.y = 34.7;
		 infoPick.text = " Picked Color info :";
		 MySetup.addChild(infoPick);
		 hexaColor.defaultTextFormat = hueColor.defaultTextFormat = format; 
		 hueColor.text = hexaColor.text = "none";
		 hexaColor.x = 544 ;
		 hexaColor.y = 34.7;
		 hexaRect.x = 516;
		 hexaRect.y = 35;
		 hueColor.x = 544;
		 hueColor.y = 55;
		 MySetup.addChild(hexaColor);
		 MySetup.addChild(hexaRect);
		 MySetup.addChild(hueColor);
		 hexaRect.graphics.lineStyle(1, 0x000000);
		 hexaRect.graphics.drawRect(0, 0, 20, 20);
		 
		 
		 
		 //Blur
		 fingersMotion.filter = new BlurFilter(fingersMotion.flou,fingersMotion.flou,2);
		 //matrice saturation
		 a = rwgt + (1 - rwgt) * fingersMotion.s;
		 b = gwgt * (1 - fingersMotion.s);
		 c = bwgt * (1 - fingersMotion.s);
		 d = rwgt * (1 - fingersMotion.s);
		 e = gwgt + (1 - gwgt) * fingersMotion.s;
		 f = bwgt * (1 - fingersMotion.s);
		 g = rwgt * (1 - fingersMotion.s);
		 h = gwgt * (1 - fingersMotion.s);
		 i = bwgt + (1 - bwgt) * fingersMotion.s;
		 satMat = new Array(a, b, c, 0, 0, d, e, f, 0, 0, g, h, i, 0, 0, 0, 0, 0, 1, 0);
		 fingersMotion.saturate = new ColorMatrixFilter(satMat);
		 
		 //Capteur Tools Select
		 
		 mainImage.load(new URLRequest("img/main.png"));
		 mainImage.contentLoaderInfo.addEventListener(Event.COMPLETE, capteurTools);
		 //bg Setup Panel
		
		 
		}
		
		
			
		
		private function activation ( pEvt:Event ):void
		{
			
			var stageW:int = stage.stageWidth;
			var stageH:int = stage.stageHeight;
			
			bgPanel.graphics.beginFill(0xFFFFFF,0.1);
			bgPanel.graphics.drawRect(0,0,stageW,stageH);
			bgPanel.graphics.endFill();
			//webcam = Camera.getCamera();
			//webcam.setMode( 320, 240, 30 );
			//webcam.addEventListener(ActivityEvent.ACTIVITY, activityHandler);
			//vid = new Video(320, 240);
			//vid.attachCamera(webcam);
			//vid.x=0;
			//vid.y=80;
			//MySetup.addChild(vid);
			conteneur = new Sprite();
			//image = new BitmapData(320, 240, false);
			//image1 = new BitmapData(320, 240, false, 0xFF000000);
			//image2 = new BitmapData(320, 240, false, 0xFF000000);
			//image3 = new BitmapData(320,2540, false, 0xFF000000),
			//imageB = new Bitmap(image);
			
			//imageO = new Bitmap(image);
			//imageF = new BitmapData(320, 240, true );
			//temp = new Bitmap(imageF);
			
				
				//affichage image capturée
				var maskPreview:Shape = new Shape();
				maskPreview.graphics.beginFill(0,1);
				maskPreview.graphics.drawRoundRect(0,0,320,240,10);
				maskPreview.graphics.endFill();
				
				
				conteneur.addChild(fingersMotion.imageB);
				conteneur.x = maskPreview.x = 10;
				conteneur.y = maskPreview.y= 80;
				MySetup.addChild(maskPreview);
				conteneur.mask = maskPreview;
				MySetup.addChild(conteneur);
				
				conteneur.addChild(cadrePick);
				conteneur.addEventListener(MouseEvent.CLICK, pickerTools);
				conteneur.addEventListener(MouseEvent.MOUSE_OVER, pickerTools);
				conteneur.addEventListener(MouseEvent.MOUSE_OUT, pickerTools);
				conteneur.buttonMode = true;
				
				/*addChild(temp);
				temp.x = 320;
				temp.y = 80;*/
				//addChild(rectangle);
				MySetup.addChild(rectangle1);
				MySetup.addChild(rectangle2);
				MySetup.addChild(rectangle3);
				//lancement du timer de capture
				/*var tempo:Timer = new Timer(20);
				tempo.addEventListener(TimerEvent.TIMER, tempoHandler);
				tempo.start();*/
				
				t.addEventListener(TimerEvent.TIMER, timerHandler);
				t.start();
				
				//image.draw(vid, flip);
				//image1.draw(vid, flip);
				
			
			
			removeEventListener(Event.ADDED_TO_STAGE, activation);
		}
		private function closePanel(e:MouseEvent):void{
			switch (e.type){
				case "mouseOver":
					btnClose.graphics.clear();
					btnClose.graphics.beginFill(0xd22020);
					btnClose.graphics.drawCircle(0,0,10);
					btnClose.graphics.endFill();
					break;
				case "mouseOut":
				btnClose.graphics.clear();
				btnClose.graphics.beginFill(0x666666);
				btnClose.graphics.drawCircle(0,0,10);
				btnClose.graphics.endFill();
				break;
				case "click":
					var del:Sprite = Sprite(this.parent.getChildByName("SetupFingers1Active"));
					del.addEventListener(Event.REMOVED_FROM_STAGE, fingersMotion.resetSetup);
					this.parent.removeChild(del);
					
				break;
			}
			
		}
		private function closePanelok(e:MouseEvent):void{
			switch (e.type){
				case "mouseOver":
					btnOk.gotoAndStop(2);
					break;
				case "mouseOut":
					btnOk.gotoAndStop(1);
					break;
				case "click":
					var del:Sprite = Sprite(this.parent.getChildByName("SetupFingers1Active"));
					del.addEventListener(Event.REMOVED_FROM_STAGE, fingersMotion.resetSetup);
					this.parent.removeChild(del);
					
					break;
			}
			
		}
		private function capteurTools(evt:Event):void {
			
			mainImage.x = 370;
			mainImage.y = 80;
			MySetup.addChild(mainImage);
			selectCapteur1.x = 434;
			selectCapteur1.y = 79;
			selectCapteur2.y = 81;
			selectCapteur2.x = 482.4;
			
			selectCapteur3.x =530 ;
			selectCapteur3.y = 182 ;
			hueToleranceSlider.value = fingersMotion.hueTol1;
			lumToleranceSlider.value = fingersMotion.lumTol1;
			hueToleranceLabel.text = fingersMotion.hueTol1+"° deg";
			lumToleranceLabel.text = fingersMotion.lumTol1+"";
			selectCapteur1.graphics.lineStyle(2,0x0000FF);
			selectCapteur1.graphics.beginFill(0x0000FF,0);
			selectCapteur1.graphics.drawRect(0, 0, 36, 48);
			selectCapteur1.graphics.endFill();
			selectCapteur2.graphics.lineStyle(1,0x555555);
			selectCapteur2.graphics.beginFill(0xFFFF00,0);
			selectCapteur2.graphics.drawRect(0, 0, 36, 48);
			selectCapteur2.graphics.endFill();
			selectCapteur3.graphics.lineStyle(1,0x555555);
			selectCapteur3.graphics.beginFill(0x00FF00,0);
			selectCapteur3.graphics.drawRect(0, 0, 60, 42);
			selectCapteur3.graphics.endFill();
			selectCapteur1.name ="capt1";
			selectCapteur2.name ="capt2";
			selectCapteur3.name ="capt3";
			MySetup.addChild(selectCapteur1);
			MySetup.addChild(selectCapteur2);
			MySetup.addChild(selectCapteur3);
			selectCapteur1.buttonMode = selectCapteur2.buttonMode = selectCapteur3.buttonMode = true;
			selectCapteur1.addEventListener(MouseEvent.CLICK, function():void { capteur1 = true; capteur2 = false; capteur3 = false; selectCapteur1.graphics.clear(); selectCapteur1.graphics.lineStyle(2,0x0000FF);	selectCapteur1.graphics.beginFill(0x0000FF,0);selectCapteur1.graphics.drawRect(0, 0, 36, 48);selectCapteur1.graphics.endFill();
				selectCapteur2.graphics.clear();
				selectCapteur2.graphics.lineStyle(1,0x555555);
				selectCapteur2.graphics.beginFill(0x0000FF,0);
				selectCapteur2.graphics.drawRect(0, 0, 36, 48);
				selectCapteur2.graphics.endFill();
				selectCapteur3.graphics.clear();
				selectCapteur3.graphics.lineStyle(1,0x555555);
				selectCapteur3.graphics.beginFill(0x0000FF,0);
				selectCapteur3.graphics.drawRect(0, 0, 60, 42);
				selectCapteur3.graphics.endFill();
				hueToleranceSlider.value = fingersMotion.hueTol1;
				lumToleranceSlider.value = fingersMotion.lumTol1;
				hueToleranceLabel.text = fingersMotion.hueTol1+"° deg";
				lumToleranceLabel.text = fingersMotion.lumTol1+"";
				nbreRange.text = "Nombre de couleurs à détecter : "+fingersMotion.colorCapteur1.length;} );
			selectCapteur2.addEventListener(MouseEvent.CLICK, function():void { capteur1 = false; capteur2 = true; capteur3 = false; selectCapteur2.graphics.clear();selectCapteur2.graphics.lineStyle(2,0xFFFF00);selectCapteur2.graphics.beginFill(0x0000FF,0);selectCapteur2.graphics.drawRect(0, 0, 36, 48);	selectCapteur2.graphics.endFill();
				selectCapteur1.graphics.clear();
				selectCapteur1.graphics.lineStyle(1,0x555555);
				selectCapteur1.graphics.beginFill(0x0000FF,0);
				selectCapteur1.graphics.drawRect(0, 0, 36, 48);
				selectCapteur1.graphics.endFill();
				selectCapteur3.graphics.clear();
				selectCapteur3.graphics.lineStyle(1,0x555555);
				selectCapteur3.graphics.beginFill(0x0000FF,0);
				selectCapteur3.graphics.drawRect(0, 0, 60, 42);
				selectCapteur3.graphics.endFill();
				hueToleranceSlider.value = fingersMotion.hueTol2;
				lumToleranceSlider.value = fingersMotion.lumTol2;
				hueToleranceLabel.text = fingersMotion.hueTol2+"° deg";
				lumToleranceLabel.text = fingersMotion.lumTol2+"";
				nbreRange.text = "Nombre de couleurs à détecter : "+fingersMotion.colorCapteur2.length;} );
			selectCapteur3.addEventListener(MouseEvent.CLICK, function():void { capteur1 = false; capteur2 = false; capteur3 = true;selectCapteur3.graphics.clear();	selectCapteur3.graphics.lineStyle(2,0x00FF00);selectCapteur3.graphics.beginFill(0x0000FF,0);selectCapteur3.graphics.drawRect(0, 0, 60, 42);	selectCapteur3.graphics.endFill();
				selectCapteur2.graphics.clear();
				selectCapteur2.graphics.lineStyle(1,0x555555);
				selectCapteur2.graphics.beginFill(0x0000FF,0);
				selectCapteur2.graphics.drawRect(0, 0, 36, 48);
				selectCapteur2.graphics.endFill();
				selectCapteur1.graphics.clear();
				selectCapteur1.graphics.lineStyle(1,0x555555);
				selectCapteur1.graphics.beginFill(0x0000FF,0);
				selectCapteur1.graphics.drawRect(0, 0, 36, 48);
				selectCapteur1.graphics.endFill();
				hueToleranceSlider.value = fingersMotion.hueTol3;
				lumToleranceSlider.value = fingersMotion.lumTol3;
				hueToleranceLabel.text = fingersMotion.hueTol3+"° deg";
				lumToleranceLabel.text = fingersMotion.lumTol3+"";
				nbreRange.text = "Nombre de couleurs à détecter : "+fingersMotion.colorCapteur3.length;} );
			
			selectCapteur1.addEventListener(MouseEvent.MOUSE_OVER, selectCapteur);
			selectCapteur2.addEventListener(MouseEvent.MOUSE_OVER, selectCapteur);
			selectCapteur3.addEventListener(MouseEvent.MOUSE_OVER, selectCapteur);
			
			selectCapteur1.addEventListener(MouseEvent.MOUSE_OUT, selectCapteur);
			selectCapteur2.addEventListener(MouseEvent.MOUSE_OUT, selectCapteur);
			selectCapteur3.addEventListener(MouseEvent.MOUSE_OUT, selectCapteur);
			
			//Capteur Enable/Disable Switcher
		
			enableCapteur1.name = "c1";
			enableCapteur1.graphics.beginFill(0x00FF00,0);
			enableCapteur1.graphics.drawRect(0, 0, 20, 20);
			enableCapteur1.graphics.endFill();
			var checkBox:Shape = new Shape();
			checkBox.graphics.lineStyle(1,0);
			checkBox.graphics.beginFill(0xf0f0f0,1);
			checkBox.graphics.drawRect(0,0,17,17);
			checkBox.graphics.endFill();
			checkBox.x = 3;
			checkBox.y = 3;
		   enableCapteur1.addChild(checkBox);
			
			//enableCapteur1.addChild(checked1);
			enableCapteur1.x = 441;
			enableCapteur1.y = 132;
			MySetup.addChild(enableCapteur1);
			
		
			enableCapteur2.name = "c2";
			enableCapteur2.graphics.beginFill(0x00FF00,0);
			enableCapteur2.graphics.drawRect(0, 0, 20, 20);
			enableCapteur2.graphics.endFill();
			var checkBox2:Shape = new Shape();
			checkBox2.graphics.lineStyle(1,0);
			checkBox2.graphics.beginFill(0xf0f0f0,1);
			checkBox2.graphics.drawRect(0,0,17,17);
			checkBox2.graphics.endFill();
			checkBox2.x = 3;
			checkBox2.y = 3;
			enableCapteur2.addChild(checkBox2);
			
			//enableCapteur2.addChild(checked2);
			enableCapteur2.x = 441+48.4;
			enableCapteur2.y = 132;
			MySetup.addChild(enableCapteur2);
			
			enableCapteur3.name = "c3";
			enableCapteur3.graphics.beginFill(0x00FF00,0);
			enableCapteur3.graphics.drawRect(0, 0, 20, 20);
			enableCapteur3.graphics.endFill();
			var checkBox3:Shape = new Shape();
			checkBox3.graphics.lineStyle(1,0);
			checkBox3.graphics.beginFill(0xf0f0f0,1);
			checkBox3.graphics.drawRect(0,0,17,17);
			checkBox3.graphics.endFill();
			checkBox3.x = 3;
			checkBox3.y = 3;
			enableCapteur3.addChild(checkBox3);			
			//enableCapteur3.addChild(checked3);
			enableCapteur3.x = 550;
			enableCapteur3.y = 228;
			MySetup.addChild(enableCapteur3);
			
			enableCapteur1.addEventListener(MouseEvent.CLICK, enableCapteur);
			enableCapteur2.addEventListener(MouseEvent.CLICK, enableCapteur);
			enableCapteur3.addEventListener(MouseEvent.CLICK, enableCapteur);
			
			if(!fingersMotion.initCapteur1){
				enableCapteur1.addChild(checked1);
			}
			if(!fingersMotion.initCapteur2){
				enableCapteur2.addChild(checked2);
			}
			if(!fingersMotion.initCapteur3){
				enableCapteur3.addChild(checked3);
			}
			
		}
		
		private function enableCapteur(e:MouseEvent):void{
		switch (e.target.name){
			case "c1":
				if (!fingersMotion.initCapteur1){
					e.target.removeChild(checked1);
					fingersMotion.initCapteur1= true;
				}else{
					e.target.addChild(checked1);
					fingersMotion.initCapteur1=false;
				}
				trace (fingersMotion.initCapteur1);
				break;
			case "c2":
				if (!fingersMotion.initCapteur2){
					e.target.removeChild(checked2);
					fingersMotion.initCapteur2= true;
				}else{
					e.target.addChild(checked2);
					fingersMotion.initCapteur2=false;
				}
				trace (fingersMotion.initCapteur2);
				break;
			case "c3":
				if (!fingersMotion.initCapteur3){
					e.target.removeChild(checked3);
					fingersMotion.initCapteur3= true;
				}else{
					e.target.addChild(checked3);
					fingersMotion.initCapteur3=false;
				}
				trace (fingersMotion.initCapteur3);
				break;
		}
		
		}
		private function selectCapteur(e:MouseEvent):void{
			trace(e.type);
			switch(e.type){
				
			case "mouseOver":
				switch(e.target.name){
					case "capt1":
						if(!capteur1){
						selectCapteur1.graphics.clear();
						selectCapteur1.graphics.lineStyle(2,0x0000FF);
						selectCapteur1.graphics.beginFill(0x0000FF,0);
						selectCapteur1.graphics.drawRect(0, 0, 36, 48);
						selectCapteur1.graphics.endFill();
						}
						break;
					case "capt2":
						if(!capteur2){
						selectCapteur2.graphics.clear();
						selectCapteur2.graphics.lineStyle(2,0xFFFF00);
						selectCapteur2.graphics.beginFill(0x0000FF,0);
						selectCapteur2.graphics.drawRect(0, 0, 36, 48);
						selectCapteur2.graphics.endFill();
						}
						break;
					case "capt3":
						if(!capteur3){
						selectCapteur3.graphics.clear();
						selectCapteur3.graphics.lineStyle(2,0x00FF00);
						selectCapteur3.graphics.beginFill(0x0000FF,0);
						selectCapteur3.graphics.drawRect(0, 0, 60, 42);
						selectCapteur3.graphics.endFill();
						}
						break;
				}
				break;
			case "mouseOut":
				switch(e.target.name){
					case "capt1":
						if(!capteur1){
						selectCapteur1.graphics.clear();
						selectCapteur1.graphics.lineStyle(1,0x555555);
						selectCapteur1.graphics.beginFill(0x0000FF,0);
						selectCapteur1.graphics.drawRect(0, 0, 36, 48);
						selectCapteur1.graphics.endFill();
						}
						break;
					
					case "capt2":
						if(!capteur2){
						selectCapteur2.graphics.clear();
						selectCapteur2.graphics.lineStyle(1,0x555555);
						selectCapteur2.graphics.beginFill(0x0000FF,0);
						selectCapteur2.graphics.drawRect(0, 0, 36, 48);
						selectCapteur2.graphics.endFill();
						}
						break;
					
					case "capt3":
						if(!capteur3){
						selectCapteur3.graphics.clear();
						selectCapteur3.graphics.lineStyle(1,0x555555);
						selectCapteur3.graphics.beginFill(0x0000FF,0);
						selectCapteur3.graphics.drawRect(0, 0, 60, 42);
						selectCapteur3.graphics.endFill();
						}
						break;
				}
				break;
			
			}
		}
		
		private function timerHandler(evt:TimerEvent):void
		{
			//DETECTION MOUVEMENT
			/*var comparaison:BitmapData = image.compare(image1) as BitmapData;
			var Bmpdiff:Bitmap = new Bitmap(comparaison);
			imageR.draw(Bmpdiff);
			imageR.applyFilter(imageR, rect, pt, saturateGray);//filtre saturation
			imageR.applyFilter(imageR, rect, pt, filter);//filtre blur
			imageR.threshold(imageR, rect, pt, "<", 0xFFAAAAAA , 0xFF000000, 0xFFFFFFFF, true);
			imageR.threshold(imageR, rect, pt, ">", 0xFFCCCCCC, 0xFFFFFFFF, 0xFFFFFFFF, true);
			//RECTANGLE ZONE MOUVEMENT
			rectPoint = imageR.getColorBoundsRect(0xFFFFFFFF, 0xFFFFFFFF, true);
			rectangle.graphics.clear();
			rectangle.graphics.lineStyle(2, 0x0000FF);
			rectangle.graphics.drawRect((rectPoint.x + 320), (rectPoint.y + 80), rectPoint.width, rectPoint.height);
			*/
			//DETECTION COULEUR 
			//var rectCouleur:Rectangle = new Rectangle(rectPoint.x, rectPoint.y, rectPoint.width, rectPoint.height);
			//var ptCouleur:Point = new Point(rectPoint.x, rectPoint.y);
			//image.draw(fingersMotion.imageB) ;
			
			
			//image.applyFilter(image, rect, pt, filter);//filtre blur
			//image.applyFilter(image, rect, pt, saturate);//filtre blur
			
			
			//image.threshold(image, rect, pt, "<", threshold , color, maskColor, true);
			//image.threshold(image, rect, pt, "<", threshold1 , color1, maskColor1, true);
			//image.threshold(image, rect, pt, "==", threshold1 , 0xFFDE00FF, 0x00FFFFFF, true);
			rectPointF = fingersMotion.image.getColorBoundsRect(0xFFFFFFFF, 0xFF0000FF, true);
			rectPointG = fingersMotion.image.getColorBoundsRect(0xFFFFFFFF, 0xFFFFFF00, true);
			rectPointH = fingersMotion.image.getColorBoundsRect(0xFFFFFFFF, 0xFF00FF00, true);
			rectangle1.graphics.clear();
			rectangle1.graphics.lineStyle(2, 0xFFFFFF);
			rectangle1.graphics.drawRect((rectPointF.x + 10), (rectPointF.y + 80), rectPointF.width, rectPointF.height);
			
			rectangle2.graphics.clear();
			rectangle2.graphics.lineStyle(2, 0xFFFFFF);
			rectangle2.graphics.drawRect((rectPointG.x + 10), (rectPointG.y + 80), rectPointG.width, rectPointG.height);
			
			rectangle3.graphics.clear();
			rectangle3.graphics.lineStyle(2, 0xFFFFFF);
			rectangle3.graphics.drawRect((rectPointH.x + 10), (rectPointH.y + 80), rectPointH.width, rectPointH.height);
		}
		//Slider EVENT
		private function blurHandler(event:SliderEvent):void 
		{
			blurLabel.text = event.value + "%";
			fingersMotion.flou = event.value / 5;
			fingersMotion.filter = new BlurFilter(fingersMotion.flou, fingersMotion.flou, 2);
			
		}
		private function saturationHandler(event:SliderEvent):void 
		{
			saturationLabel.text = event.value + "%";
			fingersMotion.s = event.value / 50;
			a = rwgt + (1 - rwgt) * fingersMotion.s;
			b = gwgt * (1 - fingersMotion.s);
			c = bwgt * (1 - fingersMotion.s);
			d = rwgt * (1 - fingersMotion.s);
			e = gwgt + (1 - gwgt) * fingersMotion.s;
			f = bwgt * (1 - fingersMotion.s);
			g = rwgt * (1 - fingersMotion.s);
			h = gwgt * (1 - fingersMotion.s);
			i = bwgt + (1 - bwgt) * fingersMotion.s;
			var satMat:Array = new Array(a, b, c, 0, 0, d, e, f, 0, 0, g, h, i, 0, 0, 0, 0, 0, 1, 0);
			fingersMotion.saturate = new ColorMatrixFilter(satMat);
			
		}
		
		private function tolerance(event:SliderEvent):void {
			t.reset();
			tol = event.value;
			if (capteur1) {
				switch(event.target.name) {
					case "hueSlider" :
						fingersMotion.hueTol1 = tol;
						startHue = hslColorCapteur1.h - tol;
						endHue = hslColorCapteur1.h + tol;
						hueToleranceLabel.text = tol + "° deg";
						break;
				
					case "lumSlider" :
						fingersMotion.lumTol1 = tol;
						startLum = hslColorCapteur1.l - tol;
						endLum = hslColorCapteur1.l +tol;
						lumToleranceLabel.text = tol + "";
						
				}
								
				fingersMotion.colorCapteur1 = new Vector.<uint>();
				for (var i:int = startHue; i <= endHue; ++i) {
					for(var k:int=startLum; k<= endLum; ++k){
							
						fingersMotion.colorCapteur1.push(Rgb2Hex(hsl2rgb(i, hslColorCapteur1.s, k)));
					}
				}
				nbreRange.text = "Nombre de couleurs à détecter : " + fingersMotion.colorCapteur1.length;
				t.start();
				
			}
			
			if (capteur2) {
				
				switch(event.target.name) {
					case "hueSlider" :
						fingersMotion.hueTol2 = tol;
						startHue = hslColorCapteur2.h - tol;
						endHue = hslColorCapteur2.h + tol;
						hueToleranceLabel.text = tol + "° deg";
						break;
					
					case "lumSlider" :
						fingersMotion.lumTol2 = tol;
						startLum = hslColorCapteur2.l - tol;
						endLum = hslColorCapteur2.l +tol;
						lumToleranceLabel.text = tol + "";
						break;
				}
								
				fingersMotion.colorCapteur2 = new Vector.<uint>();
				for (var m:int = startHue; m <= endHue; ++m) {
					for(var o:int=startLum; o<= endLum; ++o){
						fingersMotion.colorCapteur2.push(Rgb2Hex(hsl2rgb(m, hslColorCapteur2.s, o)));
					}
				}
				
				nbreRange.text = "Nombre de couleurs à détecter : " + fingersMotion.colorCapteur2.length;	
				t.start();
				
			}
			if (capteur3) {
				
				switch(event.target.name) {
					case "hueSlider" :
						fingersMotion.hueTol3 = tol;
						startHue = hslColorCapteur3.h - tol;
						endHue = hslColorCapteur3.h + tol;
						hueToleranceLabel.text = tol + "° deg";
						break;
					
					case "lumSlider" :
						fingersMotion.lumTol3 = tol;
						startLum = hslColorCapteur3.l - tol;
						endLum = hslColorCapteur3.l +tol;
						lumToleranceLabel.text = tol+ "";
						break;
				}
				
				fingersMotion.colorCapteur3 = new Vector.<uint>();
				for (var p:int = startHue; p <= endHue; ++p) {
					for(var r:int=startLum; r<= endLum; ++r){
						fingersMotion.colorCapteur3.push(Rgb2Hex(hsl2rgb(p, hslColorCapteur3.s, r)));
					}
				}
				
				nbreRange.text = "Nombre de couleurs à détecter : " + fingersMotion.colorCapteur3.length;
				t.start();
				
			}
			
			
		}
		
		
		//Function Format Color 
		private function Rgb2Hex ( rgb:Object ):uint
		{
			return rgb.r << 16 | rgb.g << 8 | rgb.b ;
		}
		
		private function Hex2Rgb(hex:uint):Object
		{
			var rgb:Object = new Object();
			rgb.r = (hex & 0xff0000) >> 16;
			rgb.g = (hex & 0x00ff00) >> 8;
			rgb.b = hex & 0x0000ff; 
			return rgb;
		}
		private function Rgb2Hsl(red:int, green:int, blue:int):Object
		{
			var hsl:Object=new Object();
			var tmpRed:Number = red/255;
			var tmpGreen:Number = green/255;
			var tmpBlue:Number = blue/255;
			
			var minValue:Number = Math.min(tmpRed, Math.min(tmpGreen, tmpBlue));
			var maxValue:Number = Math.max(tmpRed, Math.max(tmpGreen, tmpBlue));
			var deltaRGB:Number = maxValue - minValue;
			
			var hue:Number;
			var sat:Number;
			var lum:Number = (maxValue + minValue) /2 ;
			
			if(deltaRGB == 0){
				hue = 0;
				sat = 0;
			}else{
				if(lum < 0.5){
					sat = deltaRGB / (maxValue + minValue);
				}else{
					sat = deltaRGB / (2 - maxValue - minValue);
				}
				
				var deltaR:Number = (((maxValue - tmpRed) /6) + (deltaRGB / 2))/ deltaRGB;
				var deltaG:Number = (((maxValue - tmpGreen) /6) + (deltaRGB / 2))/ deltaRGB;
				var deltaB:Number = (((maxValue - tmpBlue) /6) + (deltaRGB / 2))/ deltaRGB;
				
				switch (maxValue){
					case tmpRed :
						hue = deltaB - deltaG;
						hsl.canal = "red";
						break;
					case tmpGreen :
						hue = (1 / 3) + deltaR - deltaB ;
						hsl.canal = "green";
						break;
					case tmpBlue :
						hue = (2 / 3) + deltaG - deltaR;
						hsl.canal = "blue";
				}
				if(hue < 0){ hue += 1;}
				if(hue > 1){ hue -= 1;}
				
			}
			var hueFinal:int = Math.round(hue * 360);
			hsl.h = hueFinal;
			hsl.s = Math.round(sat*100);
			hsl.l = Math.round(lum * 100);
			
			
			return hsl ;
		}
		
		/*private function Hsl2Rgb(h:int, s:int, l:int):Object
		{
		var rgb:Object = new Object;
		var m1:Number;
		var m2:Number;
		var hue:Number;
		var sat:Number = s / 100;
		trace("sat = " + sat);
		var lum:Number = l / 100;
		trace("lum = " + lum);
		if (s == 0){
		rgb.r = rgb.g = rgb.b = (l * 255);
		}
		else
		{
		if (l <= 0.5){
		m2 = l * (s + 1);
		}else{
		m2 = l + s - l * s;
		}
		m1 = l * 2 - m2;
		hue = h / 360;
		rgb.r = HueToRgb(m1, m2, hue + 1/3);
		rgb.g = HueToRgb(m1, m2, hue);
		rgb.b = HueToRgb(m1, m2, hue - 1/3);
		
		}
		
		return rgb;
		}
		
		private function HueToRgb(m1:Number, m2:Number, hue:Number)
		{
		var v:Number;
		if (hue < 0){
		hue += 1;
		}else{
		if (hue > 1){
		hue -= 1;
		}
		if (6 * hue < 1){
		v = m1 + (m2 - m1) * hue * 6;}
		else { 
		if (2 * hue < 1){
		v = m2;
		}else {
		if (3 * hue < 2){
		v = m1 + (m2 - m1) * (2 / 3 - hue) * 6;
		}else {
		v = m1;
		}
		}
		}
		}
		return 255 * v;
		}*/
		
		private function hsl2rgb(h:int, s:Number, l:Number):Object
		{
			var rgb:Object = new Object();
			s = s / 100;
			l = l / 100;
			
			if (s == 0) {
				rgb.r = rgb.g = rgb.b = l*255;
			} else {
				var t1:Number, t2:Number, t3:Array = [0,0,0], c:Array = [0,0,0];
				if (l < .5) {
					t2 = l * (1 + s);
				} else {
					t2 = l + s - l *s;
				}
				t1 = 2 * l - t2;
				var hue:Number = h / 360;
				t3[0] = hue + 1 / 3;
				t3[1] = hue;
				t3[2] = hue - 1 / 3;
				for (var i:uint = 0; i < 3; i++) {
					if (t3[i] < 0) t3[i] += 1;
					if (t3[i] > 1) t3[i] -= 1;
					
					if (6 * t3[i] < 1) c[i] = t1 + (t2 - t1) * 6 * t3[i];
					else if (2 * t3[i] < 1) c[i] = t2;
					else if (3 * t3[i] < 2) c[i] = t1 + (t2 - t1) * ((2 / 3) - t3[i]) * 6;
					else c[i] = t1;
				}
				rgb.r = c[0] * 255;
				rgb.g = c[1] * 255;
				rgb.b = c[2] * 255;
			}
			return rgb;
		}	
		private function pickerTools(evt:MouseEvent):void
		{
			
			switch(evt.type)
			{
				
				case "mouseOver" :
					cadrePick.graphics.lineStyle(3, 0xFF0000);
					cadrePick.graphics.drawRect(0, 0, 320, 240);
					break;
				case "mouseOut" :
					cadrePick.graphics.clear();
					break;
				case "click" :
					t.stop();				
					colorPick = fingersMotion.image.getPixel(evt.localX, evt.localY);
					
					hexaColor.text = "0x" + colorPick.toString(16);
					hexaRect.graphics.clear();
					hexaRect.graphics.lineStyle(1, 0x000000);
					hexaRect.graphics.beginFill(colorPick);
					hexaRect.graphics.drawRect(0, 0, 20, 20);
					hexaRect.graphics.endFill();
					var tempRGB:Object = new Object();
					tempRGB = Hex2Rgb(colorPick);
					if(capteur1){
						hslColorCapteur1 = Rgb2Hsl(tempRGB.r, tempRGB.g, tempRGB.b);
						hueColor.text = hslColorCapteur1.h+"° deg";
						
						fingersMotion.colorCapteur1 = new Vector.<uint>();
						fingersMotion.hueTol1 = hueToleranceSlider.value;
						fingersMotion.lumTol1 = lumToleranceSlider.value;
						startHue = hslColorCapteur1.h - fingersMotion.hueTol1;
						endHue = hslColorCapteur1.h + fingersMotion.hueTol1;
						startLum = hslColorCapteur1.l - fingersMotion.lumTol1;
						endLum = hslColorCapteur1.l + fingersMotion.lumTol1;
						
						for (var i:int = startHue; i <= endHue; ++i) {
							for(var k:int=startLum; k<= endLum; ++k){
								fingersMotion.colorCapteur1.push(Rgb2Hex(hsl2rgb(i, hslColorCapteur1.s, k)));
								}
							
						}
																		
						nbreRange.text = "Nombre de couleurs à détecter : " + fingersMotion.colorCapteur1.length;
						fingersMotion.initCapteur1 = false;
						enableCapteur1.addChild(checked1);
						t.start();
					}
					if(capteur2){
						hslColorCapteur2 = Rgb2Hsl(tempRGB.r, tempRGB.g, tempRGB.b);
						hueColor.text = hslColorCapteur2.h+"° deg";
						
						fingersMotion.colorCapteur2 = new Vector.<uint>();
						fingersMotion.hueTol2 = hueToleranceSlider.value;
						
						fingersMotion.lumTol2 = lumToleranceSlider.value;
						startHue = hslColorCapteur2.h - fingersMotion.hueTol2;
						endHue = hslColorCapteur2.h + fingersMotion.hueTol2;
						
						startLum = hslColorCapteur2.l - fingersMotion.lumTol2;
						endLum = hslColorCapteur2.l + fingersMotion.lumTol2;
						
						for (var m:int = startHue; m <= endHue; ++m) {
							
								for(var o:int=startLum; o<= endLum; ++o){
									fingersMotion.colorCapteur2.push(Rgb2Hex(hsl2rgb(m, hslColorCapteur2.s, o)));
								}
							
						}
						nbreRange.text = "Nombre de couleurs à détecter : " + fingersMotion.colorCapteur2.length;
						fingersMotion.initCapteur2 = false;
						enableCapteur2.addChild(checked2);
						t.start();
					}
					if(capteur3){
						hslColorCapteur3 = Rgb2Hsl(tempRGB.r, tempRGB.g, tempRGB.b);
						hueColor.text = hslColorCapteur3.h+"° deg";
						
						fingersMotion.colorCapteur3 = new Vector.<uint>();
						fingersMotion.hueTol3 = hueToleranceSlider.value;
						fingersMotion.lumTol3 = lumToleranceSlider.value;
						startHue = hslColorCapteur3.h - fingersMotion.hueTol3;
						endHue = hslColorCapteur3.h + fingersMotion.hueTol3;
						startLum = hslColorCapteur3.l - fingersMotion.lumTol3;
						endLum = hslColorCapteur3.l + fingersMotion.lumTol3;
						
						for (var p:int = startHue; p <= endHue; ++p) {
							
								for(var r:int=startLum; r<= endLum; ++r){
									fingersMotion.colorCapteur3.push(Rgb2Hex(hsl2rgb(p, hslColorCapteur3.s, r)));
								}
							
						}
						nbreRange.text = "Nombre de couleurs à détecter : " + fingersMotion.colorCapteur3.length;
						fingersMotion.initCapteur3 = false;
						enableCapteur3.addChild(checked3);
						t.start();
					}
					
			}
			
		}
		
		
		
		
	}
}